function onCreate()
    makeLuaSprite("sonicHead","heads/Sonic_BG", 0, 0)
    makeLuaSprite("fleetwayHead","heads/Super_Sonic_BG", 0, 0)
    makeLuaSprite("initFleetwayHead", "heads/Super_Sonic_BG", 0, 0)

    makeLuaSprite("blackout", nil, 0, 0)

    makeLuaSprite("eggmanHead", "heads/Eggman_BG", 0, 0)
    makeLuaSprite("metalHead", "heads/Metallix", 0, 0)
    makeLuaSprite("brutusHead", "heads/Brutus", 0, 0)

    --setGraphicSize("sonicHead", 1280, 720, true)
    --setGraphicSize("fleetwayHead", 1280, 720, true)
    villainHeadMult = 0.25
    scaleObject("eggmanHead", villainHeadMult, villainHeadMult)
    scaleObject("metalHead", villainHeadMult, villainHeadMult)
    scaleObject("brutusHead", villainHeadMult, villainHeadMult)
    villainHeadInitWidth = getProperty("eggmanHead.width")
    villainHeadInitHeight = getProperty("eggmanHead.height")

    makeGraphic("blackout", screenWidth * 2, screenHeight * 2, "000000")

    setProperty("sonicHead.alpha", 0)
    setProperty("fleetwayHead.alpha", 0)
    setProperty("initFleetwayHead.alpha", 0)
    setProperty("blackout.alpha", 0)
    setProperty("eggmanHead.alpha", 0)
    setProperty("metalHead.alpha", 0)
    setProperty("brutusHead.alpha", 0)

    setScrollFactor("sonicHead", 0.0, 0.0)
    setScrollFactor("fleetwayHead", 0.0, 0.0)
    setScrollFactor("initFleetwayHead", 0.0, 0.0)
    setScrollFactor("blackout", 0.0, 0.0)
    setScrollFactor("eggmanHead", 0.0, 0.0)
    setScrollFactor("metalHead", 0.0, 0.0)
    setScrollFactor("brutusHead", 0.0, 0.0)

    screenCenter("sonicHead", "XY")
    screenCenter("fleetwayHead", "XY")
    screenCenter("initFleetwayHead", "XY")
    screenCenter("blackout", "XY")
    screenCenter("eggmanHead", "XY")
    screenCenter("metalHead", "XY")
    screenCenter("brutusHead", "XY")

    addLuaSprite("sonicHead", false)
    addLuaSprite("fleetwayHead", false)
    addLuaSprite("eggmanHead", true)
    addLuaSprite("metalHead", true)
    addLuaSprite("brutusHead", true)
    addLuaSprite("blackout", true)
    addLuaSprite("initFleetwayHead", true)

    fadeInTime = 2
    fadeOutTime = 0.75
    fadeInTarget = 0.4

    eggmanFadeTime = 1
    eggmanFadeDelay = 2.25
    eggmanZoomTime = 4.25
    eggmanZoomTarget = 1

    villainFadeTime = 0.75
    villainFadeDelay = 1
    villainZoomTime = 3
    villainZoomTarget = 1
end


function onEvent(eventName, value1, value2, strumTime)
    if eventName == "Head Controller" then --yeah I did this fight me
        if value1 == "sonic" then
            if value2 == "ON" then
                cancelTween("sonicHeadOut")
                doTweenAlpha("sonicHeadIn", "sonicHead", fadeInTarget, fadeInTime, "expoOut")
            elseif value2 == "OFF" then
                cancelTween("sonicHeadIn")
                doTweenAlpha("sonicHeadOut", "sonicHead", 0, fadeOutTime, "expoOut")
            end
        elseif value1 == "super" then
            if value2 == "ON" then
                cancelTween("fleetwayHeadOut")
                doTweenAlpha("fleetwayHeadIn", "fleetwayHead", fadeInTarget, fadeInTime, "expoOut")
            elseif value2 == "OFF" then
                cancelTween("fleetwayHeadIn")
                doTweenAlpha("fleetwayHeadOut", "fleetwayHead", 0, fadeOutTime, "expoOut")
            end 
        elseif value1 == "special" then
            if value2 == "Black1" then
                doTweenAlpha("blackIn", "blackout", 1, 2, "expoOut")
            elseif value2 == "Black2" then
                --doTweenAlpha("blackOut", "blackout", 0, 0.5, "expoOut")
                setProperty("blackout.alpha", 0)
            elseif value2 == "Face1" then
                doTweenAlpha("fleetwaySpecialIn", "initFleetwayHead", 1, 2, "expoIn")
            elseif value2 == "Face2" then
                --doTweenAlpha("fleetwaySpecialOut", "initFleetwayHead", 0, 0.5, "expoOut")
                cancelTween("fleetwaySpecialIn")
                setProperty("initFleetwayHead.alpha", 0)
            end
        elseif value1 == "eggman" then
            cancelTimer("eggmanHeadInTimer")
            cancelTween("eggmanHeadIn")
            cancelTween("eggmanZoom1")
            cancelTween("eggmanZoom2")
            cancelTween("eggmanHeadOut")
            setGraphicSize("eggmanHead", villainHeadInitWidth, villainHeadInitHeight)
            setProperty("eggmanHead.alpha", 0)
            doTweenAlpha("eggmanHeadIn", "eggmanHead", fadeInTarget, eggmanFadeTime, "linear")
            doTweenX("eggmanZoom1", "eggmanHead.scale", eggmanZoomTarget, eggmanZoomTime, "linear")
            doTweenY("eggmanZoom2", "eggmanHead.scale", eggmanZoomTarget, eggmanZoomTime, "linear")
        elseif value1 == "metallix" then
            cancelTimer("metalHeadInTimer")
            cancelTween("metalHeadIn")
            cancelTween("metalZoom1")
            cancelTween("metalZoom2")
            cancelTween("metalHeadOut")
            setGraphicSize("metalHead", villainHeadInitWidth, villainHeadInitHeight)
            setProperty("metalHead.alpha", 0)
            doTweenAlpha("metalHeadIn", "metalHead", fadeInTarget, eggmanFadeTime, "linear")
            doTweenX("metalZoom1", "metalHead.scale", villainZoomTarget, villainZoomTime, "linear")
            doTweenY("metalZoom2", "metalHead.scale", villainZoomTarget, villainZoomTime, "linear")
        elseif value1 == "brutus" then
            cancelTimer("brutusHeadInTimer")
            cancelTween("brutusHeadIn")
            cancelTween("brutusZoom1")
            cancelTween("brutusZoom2")
            cancelTween("brutusHeadOut")
            setGraphicSize("brutusHead", villainHeadInitWidth, villainHeadInitHeight)
            setProperty("brutusHead.alpha", 0)
            doTweenAlpha("brutusHeadIn", "brutusHead", fadeInTarget, eggmanFadeTime, "linear")
            doTweenX("brutusZoom1", "brutusHead.scale", villainZoomTarget, villainZoomTime, "linear")
            doTweenY("brutusZoom2", "brutusHead.scale", villainZoomTarget, villainZoomTime, "linear")
        else          
            debugPrint("use the event right DOOFUS")
        end
    end
end


function onTweenCompleted(tag, vars)
    if tag == "eggmanHeadIn" then
        runTimer("eggmanHeadInTimer", eggmanFadeDelay)
    elseif tag == "metalHeadIn" then
        runTimer("metalHeadInTimer", villainFadeDelay)
    elseif tag == "brutusHeadIn" then
        runTimer("brutusHeadInTimer", villainFadeDelay)
    end
end

function onTimerCompleted(tag, loops, loopsLeft)
    if tag == "eggmanHeadInTimer" then
        doTweenAlpha("eggmanHeadOut", "eggmanHead", 0, eggmanFadeTime, "linear")
    elseif tag == "metalHeadInTimer" then
        doTweenAlpha("metalHeadOut", "metalHead", 0, villainFadeTime, "linear")
    elseif tag == "brutusHeadInTimer" then
        doTweenAlpha("brutusHeadOut", "brutusHead", 0, villainFadeTime, "linear")
    end
end